
sub spamassassin {
  my($scanned)=@_ ;

  #Only run SA if mail is from a "remote" SMTP client, or QS_SPAMASSASSIN 
  #is defined via tcpserver...
  if (defined($ENV{'RELAYCLIENT'}) && !defined($ENV{'QS_SPAMASSASSIN'})) {
    &debug("spamassassin: don't scan as RELAYCLIENT implies this was sent by a local user") if (!$scanned);
    &minidebug("SA: don't scan as RELAYCLIENT implies this was sent by a local user") if (!$scanned);
    return;
  }
  if ( $SA_SKIP_MD ne "0" && $returnpath eq "" && $headers{'from'} =~ /mailer-daemon|postmaster|bounce/i ) {
    &debug("SA: skipping message from MAILER-DAEMON") if (!$scanned);
    &minidebug("SA: skipping message from MAILER-DAEMON") if (!$scanned);
    return;
  }

  #SpamAssassin client scanner
  #my ($spamassassin_found,$spamassassin_status);
  my ($spamassassin_status);
  my ($start_spamassassin_time)=[gettimeofday];
  my ($sa_tag,$DD,$cmdline_recip,$spamc_options,$sa_score,$stop_spamassassin_time,$spamassassin_time);
  my ($sa_status)=0;
  ($sa_score,$required_hits)=('0','0');
  ($sa_comment,$sa_level)=('','');

  if ($msg_size > 250000) {
    &debug("spamassassin: message too big - skip it");
    &minidebug("SA: message too big ($msg_size) - skip it");
    $sa_score=$required_hits="?";
    $tag_score .= "SA:0($sa_score/$required_hits):";
    $sa_comment = "No, hits=$sa_score required=$required_hits";
    return;
  }

  #Cleanup $one_recip so it's usable from the commandline...
  #any char that isn't supported to changed into an '_'
  ($cmdline_recip=$one_recip)=~s/[^0-9a-z\.\_\-\=\+\@]/_/gi;
  $cmdline_recip=~/^([0-9a-z\.\_\-\=\+\@]+)$/i;
  $cmdline_recip=tolower($1);

  $spamc_options=' -c ' if ($sa_fast);
  $spamc_options="$spamc_options -u \"$cmdline_recip\"" if ($cmdline_recip ne "");
  &debug("SA: run $spamc_binary $spamc_options < $scandir/$wmaildir/new/$file_id") if (!$scanned);
  open(SIN,"<$scandir/$wmaildir/new/$file_id")||&error_condition("cannot open $scandir/$wmaildir/new/$file_id - $!");
  open(SOUT,"|$spamc_binary $spamc_options > $scandir/$wmaildir/new/$file_id.spamc")||&error_condition("cannot open for write $scandir/$wmaildir/new/$file_id.spamc - $!");

  print SOUT "X-Envelope-From: $headers{'MAILFROM'}\n";
  while (<SIN>) {
    print SOUT;
  }
  close(SIN)||&error_condition("cannot close $scandir/$wmaildir/new/$file_id - $!");
  close SOUT;
  $spamassassin_status=($? >> 8);
  $sa_status=$spamassassin_status if ($sa_fast);
  open(SA,"<$scandir/$wmaildir/new/$file_id.spamc")||&error_condition("cannot open for read $scandir/$wmaildir/new/$file_id.spamc - $!");
  while (<SA>) {
    if ($sa_fast) {
      chomp;
      ($sa_score,$required_hits)=split(/\//,$_,2);
      $sa_tag++;
      last;
    } else {
      #X-Spam-Status: No, hits=2.8 required=5.0
      if (/^X-Spam-Status: (Yes|No), (hits|score)=(-?[\d\.]*) required=([\d\.]*)/) {
        $sa_tag++;
        $sa_status=1 if ($1 eq "Yes");
        $sa_score=$3;$required_hits=$4;
      }
    }
  }
  close SA ;

  if (!$sa_fast && -s "$scandir/$wmaildir/new/$file_id.spamc" && $spamassassin_status == 0) {
    &debug("SA: overwriting $scandir/$wmaildir/new/$file_id with $scandir/$wmaildir/new/$file_id.spamc");
    rename ("$scandir/$wmaildir/new/$file_id.spamc","$scandir/$wmaildir/new/$file_id");
  } else {
    unlink("$scandir/$wmaildir/new/$file_id.spamc");
  }

  # st: new routine to avoid duplicate code, so a shorter code...
  &check_sa_score($sa_score,$start_spamassassin_time,$scanned);

  $stop_spamassassin_time=[gettimeofday];
  $spamassassin_time = tv_interval ($start_spamassassin_time, $stop_spamassassin_time);

  &debug("SA: finished scan of dir \"$ENV{'TMPDIR'}\" in $spamassassin_time secs");
  &minidebug("SA: finished scan in $spamassassin_time secs - hits=$sa_hits");
}

#################################################
# Spamassassin subroutine added by ST
#################################################

sub spamassassin_alt {
  # st: Alternative routine for spamassassin, lighter and can logs the report...
  my($scanned)=@_ ;

  #Only run SA if mail is from a "remote" SMTP client, or QS_SPAMASSASSIN 
  #is defined via tcpserver...
  if (defined($ENV{'RELAYCLIENT'}) && !defined($ENV{'QS_SPAMASSASSIN'})) {
    &debug("spamassassin: don't scan as RELAYCLIENT implies this was sent by a local user") if (!$scanned);
    &minidebug("SA: don't scan as RELAYCLIENT implies this was sent by a local user") if (!$scanned);
    return;
  }
  if ( $SA_SKIP_MD ne "0" && $returnpath eq "" && $headers{'from'} =~ /mailer-daemon|postmaster|bounce/i ) {
    &debug("SA: skipping message from MAILER-DAEMON") if (!$scanned);
    &minidebug("SA: skipping message from MAILER-DAEMON") if (!$scanned);
    return;
  }

  #SpamAssassin client scanner
  my ($start_spamassassin_time)=[gettimeofday];
  my ($spamc_options,$sa_tag,$spamassassin_status,$sa_score,$stop_spamassassin_time,$spamassassin_time);
  my ($sa_status)=0;
  ($sa_score,$required_hits)=('0','0');
  ($sa_comment,$sa_level)=('','');
  $sa_report='';
  $sa_fast=1;

  if ($msg_size > 250000) {
    &debug("spamassassin: message too big - skip it");
    &minidebug("SA: message too big - skip it");
    $sa_score=$required_hits="?";
    $tag_score .= "SA:0($sa_score/$required_hits):";
    $sa_comment = "No, hits=$sa_score required=$required_hits";
    return;
  }

  if ( $sa_debug eq "1" ) {
     $spamc_options=" -R ";
  } else {
     $spamc_options=" -c ";
  }

  if ($sa_sql) {
     my ($cmdline_recip);
     ($cmdline_recip=$one_recip)=~s/[^0-9a-z\.\_\-\=\+\@]/_/gi;
     $cmdline_recip=~/^([0-9a-z\.\_\-\=\+\@]+)$/i;
     $cmdline_recip=tolower($1);
     $spamc_options="$spamc_options -u \"$cmdline_recip\"" if ($cmdline_recip ne "");
  }

  open(SA,"$spamc_binary $spamc_options  < $scandir/$wmaildir/new/$file_id|")||&error_condition("cannot run $spamc_binary  < $scandir/$wmaildir/new/$file_id - $!");
  while (<SA>) {
    if (!$sa_tag) {
       chomp;
       ($sa_score,$required_hits)=split(/\//,$_,2);
       # Clean some invalid returns from SA v.2.5x
       $required_hits =~ s/\r//g;
       chomp $required_hits;
       $sa_tag=1;
       next;
    }

    if ( $sa_tag<2 ) {
       $sa_tag=2 if (/^---- ---------------------- --------------------------------------------------$/);
       next;
    }

    $sa_report .= " $_" if ( !/^$/ || !/^\s$/ );
  }

  # Clean some invalid returns from SA v.2.5x
  $sa_report =~ s/\r/\n/g;
  chomp $sa_report;
  $sa_report = '' if ($sa_report =~ /\n\n/ );

  $spamassassin_status=($? >> 8);
  $sa_status=$spamassassin_status if ($sa_fast);

  close SA ;

  # st: new routine to avoid duplicate code, so a shorter code...
  &check_sa_score($sa_score,$start_spamassassin_time,$scanned);

  $stop_spamassassin_time=[gettimeofday];
  $spamassassin_time = tv_interval ($start_spamassassin_time, $stop_spamassassin_time);

  &debug("SA: finished scan of dir \"$ENV{'TMPDIR'}\" in $spamassassin_time secs");
  &minidebug("SA: finished scan in $spamassassin_time secs - hits=$sa_hits");
}

sub check_sa_score {
  my ($sa_score,$start_spamassassin_time,$scanned)=@_ ;
  my ($stop_spamassassin_time,$spamassassin_time);

  $sa_score='?' if (!$sa_score);
  $required_hits='?' if (!$required_hits);

  &debug("SA: REPORT hits = $sa_score/$required_hits\n$sa_report") if ( $sa_debug && $sa_report && !$scanned);
  &minidebug("SA: REPORT hits = $sa_score/$required_hits\n$sa_report") if ( $sa_debug && $sa_report && !$scanned);

  # st: what about SA sql per user, could be differents $required_hits...
  if ($required_hits > $sa_score || ($sa_score == 0) || ($sa_score eq "\?")) {
    $tag_score .= "SA:0($sa_score/$required_hits):";
    $sa_comment = "No, hits=$sa_score required=$required_hits";
  } else {
    $tag_score .= "SA:1($sa_score/$required_hits):";
    $sa_comment = "Yes, hits=$sa_score required=$required_hits" if ($sa_fast);

    # If sa_quarantine/sa_delete are set, then compare them to the current score and
    # quarantine/delete it if necessary,
    # otherwise tag the message as spam.

    # Control the values of sa_delete and sa_quarantine
    if ($sa_delete && ($sa_quarantine>$sa_delete) && !$scanned) {
      &debug("SA: WARNING, sa_delete is lower than sa_quarantine, spam could be quarantined, but not deleted");
      &minidebug("SA: WARNING, sa_delete is lower than sa_quarantine, spam could be quarantined, but not deleted");
      $sa_delete='0';
    }

    if ( $sa_delete && (($sa_delete+$required_hits)<$sa_score)) {
       if ( $sa_reject && (($sa_delete_site+$required_hits)<$sa_score)) {
          &debug("SA: yup, this smells like SPAM - hits=$sa_score - rejecting message...");
          &minidebug("SA: yup, this smells like SPAM - hits=$sa_score - rejecting message...");
          $stop_spamassassin_time=[gettimeofday];
          $spamassassin_time = tv_interval ($start_spamassassin_time, $stop_spamassassin_time);
          &debug("SA: finished scan of dir \"$ENV{'TMPDIR'}\" in $spamassassin_time secs");
          &minidebug("SA: finished scan in $spamassassin_time secs - hits=$sa_score");
          &reject_email("We have reasons to believe this mail is SPAM",31);
       } else {
          # st: mark the message to delete it, if it isn't already marked as virus to delete
          # actually it is not possible that a marke message reach this point. I think..
          $del_message='2' if ($del_message ne "1");
          # st: maybe these three lines are useful for those who wants the 'log_details'...
          # But if the message is rejected nothing remains
          $destring="problem";
          $quarantine_description="SPAM exceeds \"delete\" threshold - hits=$sa_score/$required_hits";
          $quarantine_event="SA:SPAM-DELETE";
          if (!$scanned) {
             &debug("SA: yup, this smells like SPAM - hits=$sa_score - deleting message...");
             &minidebug("SA: yup, this smells like SPAM - hits=$sa_score - deleting message...");
          }
          $description .= "\n---spamassassin results ---\n$destring '$quarantine_description'\n found in message $ENV{'TMPDIR'}";
       }
    } else {
       if ( $sa_quarantine && (($sa_quarantine+$required_hits)<$sa_score)) {
          $destring="problem";
          $quarantine_description="SPAM exceeds \"quarantine\" threshold - hits=$sa_score/$required_hits";
          $quarantine_event="SA:SPAM-QUARANTINE";
          if (!$scanned) {
             &debug("SA: yup, this smells like SPAM - hits=$sa_score - quarantining message...");
             &minidebug("SA: yup, this smells like SPAM - hits=$sa_score - quarantining message...");
          }
          $description .= "\n---spamassassin results ---\n$destring '$quarantine_description'\n found in message $ENV{'TMPDIR'}";
       } else {
          #st: if $spamc_subjec and $sa_delta are set, add in the subject the spam-level
          if ($sa_subject ne "" && $sa_delta) {
             if ($sa_score < ($required_hits+$sa_delta)) {
                $sa_subject .= " LOW * ";
             } elsif ($sa_score > ($required_hits+(2 * $sa_delta))) {
                $sa_subject .= " HIGH * ";
             } else {
                $sa_subject .= " MEDIUM * ";
             }
          }
          if (!$scanned) {
             &debug("SA: yup, this smells like SPAM - hits=$sa_score - tagging message...");
             &minidebug("SA: yup, this smells like SPAM - hits=$sa_score - tagging message...");
          }
       }
    }
  }

  $sa_hits=$sa_score;
  if ($sa_score > 0) {
    $sa_score=int($sa_score);
    #Keep it RFC compliant
    $sa_score=100 if ($sa_score > 100);
    my $si=0;
    if ($sa_fast || $sa_alt) {
      while ($si < $sa_score) {
        $si++;
        $sa_level .= $sa_symbol;
      }
    }
  }

  if (!$scanned) {
     &debug("SA: required_hits $required_hits / sa_quarantine +$sa_quarantine / sa_delete +$sa_delete") if ($sa_quarantine || $sa_delete);
     &minidebug("SA: required_hits $required_hits / sa_quarantine +$sa_quarantine / sa_delete +$sa_delete") if ($sa_quarantine || $sa_delete);
  }
}

#################################################
# END of Spamassassin subroutines added by ST
#################################################

